;ATMega169 Code
;Quarz 8Mhz also 250ns pro Takt

.include "m169def.inc"

.def temp     = r16
.def temp2    = r17
.def rBin1L   = r18
.def rBin1H   = r19
.def rBin2L   = r20
.def rBin2H   = r21
.def rmp      = r22

.def _1er     = r10
.def _10er    = r11
.def _100er   = r12
.def _1000er  = r13
.def _10000er = r14

.equ BCD0 = 0b0111111
.equ BCD1 = 0b0000110
.equ BCD2 = 0b1011011
.equ BCD3 = 0b1001111
.equ BCD4 = 0b1100110
.equ BCD5 = 0b1101101
.equ BCD6 = 0b1111101
.equ BCD7 = 0b0000111
.equ BCD8 = 0b1111111
.equ BCD9 = 0b1101111


;Stackpointer
	ldi temp, LOW(RAMEND)
	out SPL, temp
	ldi temp, HIGH(RAMEND)
	out SPH, temp

;Z-Speicher Pointer
	;Speicherpointer yl(r28) yh(r29) 
	ldi zh,0x00    
	;0x0060 
	ldi zl,0x0060            


;Timer starten - es wird 16bit Timer verwendet.
;Vorteiler auf CLK/8, bei 8MHz Quarz ergibt 
;das 1s Auflsung
	ldi temp,0b00000010	
	sts TCCR1B,temp;TCCR1A/B ist Timer-Controlregister
	;sts TCCR1A,temp


;die Haupt Schleife, die 1000 mal  durchgegangen wird
;(zu Testzwecken nur 100Mal)
	ldi temp2,0x0A;1 Takt
loop:
	ldi temp,0x64;10? Takte
loop_:
	dec temp;100? Takte
	brne loop_;200? Takte
	dec temp2;10? Takte
	brne loop ;11? Takte
	;insgesamt 242 Takte x 250ns = 60.5s ??


;Timer anhalten
	ldi temp,0b00000000
	sts TCCR1B,temp;TCCR1A/B ist Timer-Controlregister
	;sts TCCR1A,temp2

;Messergibnis abfragen
	
	lds rBin1L,TCNT1L; TCNT1H/L ist Timer-Stand Register
	lds rBin1H,TCNT1H

	;ldi rBin1L,LOW(37856)
	;ldi rBin1H,HIGH(37856)
;Hier muss ein Decoder rein,der aus einer 16bit 
;Zahl BCD-Code erzeugt.

	rcall Bin2ToBcd5 
	;rcall 
;Ergibnies auf dem LCD-Display anzeigen
;nur das ist nicht ganz sooo simpel	

	ld  _10000er,z+
	mov temp,_10000er
	rcall ByteToBcd
	sts LCDDR6,temp
	
	ld _1000er,z+
	mov temp,_1000er
	rcall ByteToBcd
	sts  LCDDR5,temp


	ld  _100er,z+
	mov temp,_100er
	rcall ByteToBcd
	sts LCDDR2,temp


	ld  _10er,z+
	mov temp,_10er
	rcall ByteToBcd
	sts LCDDR1,temp


	ld  _1er,z+
	mov temp,_1er
	rcall ByteToBcd
	sts LCDDR0,temp

end:
	rjmp end


ByteToBcd:

ByteToBcd_0:
		cpi temp,0	
		brne ByteToBcd_1
		ldi temp,BCD0
		ret 
ByteToBcd_1:
		cpi temp,1
		brne  ByteToBcd_2
		ldi temp,BCD1
		ret 
ByteToBcd_2:
		cpi temp,2
		brne  ByteToBcd_3
		ldi temp,BCD2
		ret 
ByteToBcd_3:
		cpi temp,3
		brne  ByteToBcd_4
		ldi temp,BCD3
		ret 
ByteToBcd_4:
		cpi temp,4
		brne  ByteToBcd_5
		ldi temp,BCD4
		ret 
ByteToBcd_5:
		cpi temp,5
		brne  ByteToBcd_6
		ldi temp,BCD5
		ret 
ByteToBcd_6:
		cpi temp,6
		brne  ByteToBcd_7
		ldi temp,BCD6
		ret 
ByteToBcd_7:
		cpi temp,7
		brne  ByteToBcd_8
		ldi temp,BCD7
		ret 
ByteToBcd_8:
		cpi temp,8
		brne  ByteToBcd_9
		ldi temp,BCD8
		ret 
ByteToBcd_9:
		cpi temp,9
		;breq  ByteToBcd_x
		ldi temp,BCD9
		ret 

;*******************************************************
;Umwandlund von binr nach bcd
;Quelle:
;http://www.avr-asm-tutorial.net/avr_de/rechnen/konvert.html#bin2bcd


;
; Bin2ToBcd5
; ==========
; wandelt 16-Bit-Binrzahl in 5-stellige BCD-Zahl um
; Aufruf: 16-Bit-Binrzahl in rBin1H:L, Z zeigt auf die
; erste Stelle der BCD-kodierten Resultats
; Stellen: Die BCD-Zahl hat exakt 5 gltige Stellen.
; Rckkehr: Z zeigt auf die hchste BCD-Stelle
; Bentigte Register: rBin1H:L (wird erhalten), rBin2H:L
;   (wird nicht wieder hergestellt), rmp
; Aufgerufene Unterroutinen: Bin2ToDigit
;
Bin2ToBcd5:
	push rBin1H ; Rette Inhalt der Register rBin1H:L
	push rBin1L
	ldi rmp,HIGH(10000) ; Lade 10.000 in rBin2H:L
	mov rBin2H,rmp
	ldi rmp,LOW(10000)
	mov rBin2L,rmp
	rcall Bin2ToDigit ; Ermittle 5.Stelle durch Abziehen
	ldi rmp,HIGH(1000) ; Lade 1.000 in rBin2H:L
	mov rBin2H,rmp
	ldi rmp,LOW(1000)
	mov rBin2L,rmp
	rcall Bin2ToDigit ; Ermittle 4.Stelle durch Abziehen
	ldi rmp,HIGH(100) ; Lade 100 in rBin2H:L
	mov rBin2H,rmp
	ldi rmp,LOW(100)
	mov rBin2L,rmp
	rcall Bin2ToDigit ; Ermittle 3.Stelle durch Abziehen
	ldi rmp,HIGH(10) ; Lade 10 in rBin2H:L
	mov rBin2H,rmp
	ldi rmp,LOW(10)
	mov rBin2L,rmp
	rcall Bin2ToDigit ; Ermittle 2.Stelle durch Abziehen
	st z,rBin1L ; Rest sind Einer
	sbiw ZL,4 ; Setze Zeiger Z auf 5.Stelle (erste Ziffer)
	pop rBin1L ; Stelle den Originalwert wieder her
	pop rBin1H
	ret ; und kehre zurck

;
; Bin2ToDigit
; ===========
; ermittelt eine dezimale Ziffer durch fortgesetztes Abziehen
; einer binr kodierten Dezimalstelle
; Unterroutine benutzt von: Bin2ToBcd5, Bin2ToAsc5, Bin2ToAsc
; Aufruf: Binrzahl in rBin1H:L, binr kodierte Dezimalzahl
;   in rBin2H:L, Z zeigt auf bearbeitete BCD-Ziffer
; Rckkehr: Ergebis in Z (bei Aufruf), Z um eine Stelle er-
;   hht, keine Fehlerbehandlung
; Benutzte Register: rBin1H:L (enthlt Rest der Binrzahl),
;   rBin2H (bleibt erhalten), rmp
; Aufgerufene Unterroutinen: -
;
Bin2ToDigit:
	clr rmp ; Zhler auf Null
Bin2ToDigita:
	cp rBin1H,rBin2H ; Vergleiche MSBs miteinander
	brcs Bin2ToDigitc ; MSB Binrzahl kleiner, fertig
	brne Bin2ToDigitb ; MSB Binrzahl grer, subtrahiere
	cp rBin1L,rBin2L ; MSB gleich, vergleiche LSBs
	brcs Bin2ToDigitc ; LSB Binrzahl kleiner, fertig
Bin2ToDigitb:
	sub rBin1L,rBin2L ; Subtrahiere LSB Dezimalzahl
	sbc rBin1H,rBin2H ; Subtrahiere Carry und MSB
	inc rmp ; Erhhe den Zhler
	rjmp Bin2ToDigita ; Weiter vergleichen/subtrahieren
Bin2ToDigitc:
	st z+,rmp ; Speichere das Ergebnis und erhhe Zeiger
	ret ; zurck









